package com.inputstick.api.layout;

public class RussianLayout extends KeyboardLayout {
	
	public static final String LOCALE_NAME = "ru-RU";
	
	public static final int LUT[][] = {
	/*	0	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	1	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	2	*/	{	0	,	(int)'1'	,	0x21	,	-1	,	-1	,	-1	}	,
	/*	3	*/	{	0	,	(int)'2'	,	0x22	,	-1	,	-1	,	-1	}	,
	/*	4	*/	{	0	,	(int)'3'	,	0x2116	,	-1	,	-1	,	-1	}	,
	/*	5	*/	{	0	,	(int)'4'	,	0x003b	,	-1	,	-1	,	-1	}	,
	/*	6	*/	{	0	,	(int)'5'	,	0x25	,	-1	,	-1	,	-1	}	,
	/*	7	*/	{	0	,	(int)'6'	,	0x003a	,	-1	,	-1	,	-1	}	,
	/*	8	*/	{	0	,	(int)'7'	,	0x003f	,	-1	,	-1	,	-1	}	,
	/*	9	*/	{	0	,	(int)'8'	,	0x002a	,	-1	,	-1	,	-1	}	,
	/*	0a	*/	{	0	,	(int)'9'	,	0x28	,	-1	,	-1	,	-1	}	,
	/*	0b	*/	{	0	,	(int)'0'	,	0x29	,	-1	,	-1	,	-1	}	,
	/*	0c	*/	{	0	,	0x002d	,	0x005f	,	-1	,	-1	,	-1	}	,
	/*	0d	*/	{	0	,	0x003d	,	0x002b	,	-1	,	-1	,	-1	}	,
	/*	0e	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	0f	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	
	/*	10	*/	{	1	,	0x439	,	0x419	,	-1	,	-1	,	-1	}	,
	/*	11	*/	{	1	,	0x446	,	0x426	,	-1	,	-1	,	-1	}	,
	/*	12	*/	{	1	,	0x443	,	0x423	,	-1	,	-1	,	-1	}	,
	/*	13	*/	{	1	,	0x043a	,	0x041a	,	-1	,	-1	,	-1	}	,
	/*	14	*/	{	1	,	0x435	,	0x415	,	-1	,	-1	,	-1	}	,
	/*	15	*/	{	1	,	0x043d	,	0x041d	,	-1	,	-1	,	-1	}	,
	/*	16	*/	{	1	,	0x433	,	0x413	,	-1	,	-1	,	-1	}	,
	/*	17	*/	{	1	,	0x448	,	0x428	,	-1	,	-1	,	-1	}	,
	/*	18	*/	{	1	,	0x449	,	0x429	,	-1	,	-1	,	-1	}	,
	/*	19	*/	{	1	,	0x437	,	0x417	,	-1	,	-1	,	-1	}	,
	/*	1a	*/	{	1	,	0x445	,	0x425	,	-1	,	-1	,	-1	}	,
	/*	1b	*/	{	1	,	0x044a	,	0x042a	,	-1	,	-1	,	-1	}	,
	/*	1c	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	1d	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	1e	*/	{	1	,	0x444	,	0x424	,	-1	,	-1	,	-1	}	,
	/*	1f	*/	{	1	,	0x044b	,	0x042b	,	-1	,	-1	,	-1	}	,
	
	
	/*	20	*/	{	1	,	0x432	,	0x412	,	-1	,	-1	,	-1	}	,
	/*	21	*/	{	1	,	0x430	,	0x410	,	-1	,	-1	,	-1	}	,
	/*	22	*/	{	1	,	0x043f	,	0x041f	,	-1	,	-1	,	-1	}	,
	/*	23	*/	{	1	,	0x440	,	0x420	,	-1	,	-1	,	-1	}	,
	/*	24	*/	{	1	,	0x043e	,	0x041e	,	-1	,	-1	,	-1	}	,
	/*	25	*/	{	1	,	0x043b	,	0x041b	,	-1	,	-1	,	-1	}	,
	/*	26	*/	{	1	,	0x434	,	0x414	,	-1	,	-1	,	-1	}	,
	/*	27	*/	{	1	,	0x436	,	0x416	,	-1	,	-1	,	-1	}	,
	/*	28	*/	{	1	,	0x044d	,	0x042d	,	-1	,	-1	,	-1	}	,
	/*	29	*/	{	1	,	0x451	,	0x401	,	-1	,	-1	,	-1	}	,
	/*	2a	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	2b	*/	{	0	,	0x005c	,	0x002f	,	0x001c	,	-1	,	-1	}	,
	/*	2c	*/	{	1	,	0x044f	,	0x042f	,	-1	,	-1	,	-1	}	,
	/*	2d	*/	{	1	,	0x447	,	0x427	,	-1	,	-1	,	-1	}	,
	/*	2e	*/	{	1	,	0x441	,	0x421	,	-1	,	-1	,	-1	}	,
	/*	2f	*/	{	1	,	0x043c	,	0x041c	,	-1	,	-1	,	-1	}	,
	
	
	/*	30	*/	{	1	,	0x438	,	0x418	,	-1	,	-1	,	-1	}	,
	/*	31	*/	{	1	,	0x442	,	0x422	,	-1	,	-1	,	-1	}	,
	/*	32	*/	{	1	,	0x044c	,	0x042c	,	-1	,	-1	,	-1	}	,
	/*	33	*/	{	1	,	0x431	,	0x411	,	-1	,	-1	,	-1	}	,
	/*	34	*/	{	1	,	0x044e	,	0x042e	,	-1	,	-1	,	-1	}	,
	/*	35	*/	{	0	,	0x002e	,	0x002c	,	-1	,	-1	,	-1	}	,
	/*	36	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	37	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	38	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	39	*/	{	0	,	0x20	,	0x20	,	0x20	,	-1	,	-1	}	,
	/*	3a	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	3b	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	3c	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	3d	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	3e	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	3f	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	
	/*	40	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	41	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	42	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	43	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	44	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	45	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	46	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	47	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,	
	/*	48	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	49	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	4a	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	4b	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	4c	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	4d	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	4e	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	4f	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	
	
	/*	50	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	51	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,	
	/*	52	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	53	*/	{	0	,	0x002c	,	0x002c	,	-1	,	-1	,	-1	}	,
	/*	54	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	55	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	56	*/	{	0	,	0x005c	,	0x002f	,	0x001c	,	-1	,	-1	}	,
	/*	57	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,	
	/*	58	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	59	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	5a	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	5b	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	5c	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	5d	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	5e	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,
	/*	5f	*/	{	-1	,	0			,	0		,	0	,	0	,	0	}	,				
		
	};
	
	private static RussianLayout instance = new RussianLayout();
	
	private RussianLayout() {
	}
	
	public static RussianLayout getInstance() {
		return instance;
	}	
	
	@Override
	public int[][] getLUT() {
		return LUT;
	}

	@Override
	public void type(String text) {
		super.type(LUT, text);
	}	
	
	@Override
	public char getChar(int scanCode, boolean capsLock, boolean shift, boolean altGr) {
		return super.getChar(LUT, scanCode, capsLock, shift, altGr);
	}	
	
	@Override
	public String getLocaleName() {		
		return LOCALE_NAME;
	}		

}
